#ifndef DESCPWRITE_H_
#define DESCPWRITE_H_

#include "CtlPanel1.h"

typedef union{
	unsigned char D8[256];
	unsigned int  D32[64];
}TReadWriteData;

class TDescpWrite{
	public:
		static constexpr unsigned short hList[12] = {72,72,72,72,	72,72,34,34,	34,34,34,34};
		static constexpr unsigned short wList[12] = {800,290,290,290,	290,290,290,290,	290,290,290,290};
		static constexpr TLv Lv = {
			.Caption.Left = 0,
			.Caption.Top = 36,
			.Caption.Width = 800,
			.Caption.Heigh = 32,
			.Caption.Right = 800 -0 -1,
			.Caption.Bottom = 36 + 32,
			
			.Grid.Left = {0,0,0,0,	0,0,0,0,	0,0,0,0},
			.Grid.Right = {wList[0]-1,wList[1]-1,wList[2]-1,wList[3]-1,	wList[4]-1,wList[5]-1,wList[6]-1,wList[7]-1,	wList[8]-1,wList[9]-1,wList[10]-1,wList[11]-1},
			.Grid.Top[0] = (36 + 32 +2),
			.Grid.Top[1] = (36 + 32 +2) + (2 + hList[0]),
			.Grid.Top[2] = (36 + 32 +2) + (2 + hList[0]) + (2 + hList[1]),
			.Grid.Top[3] = (36 + 32 +2) + (2 + hList[0]) + (2 + hList[1]) + (2 + hList[2]),
			.Grid.Top[4] = (36 + 32 +2) + (2 + hList[0]) + (2 + hList[1]) + (2 + hList[2]) + (2 + hList[3]),
			.Grid.Top[5] = (36 + 32 +2) + (2 + hList[0]) + (2 + hList[1]) + (2 + hList[2]) + (2 + hList[3]) + (2 + hList[4]),
			.Grid.Top[6] = (36 + 32 +2) + (2 + hList[0]) + (2 + hList[1]) + (2 + hList[2]) + (2 + hList[3]) + (2 + hList[4]) + (2 + hList[5]),
			.Grid.Top[7] = (36 + 32 +2) + (2 + hList[0]) + (2 + hList[1]) + (2 + hList[2]) + (2 + hList[3]) + (2 + hList[4]) + (2 + hList[5]) + (2 + hList[6]),
			.Grid.Top[8] = (36 + 32 +2) + (2 + hList[0]) + (2 + hList[1]) + (2 + hList[2]) + (2 + hList[3]) + (2 + hList[4]) + (2 + hList[5]) + (2 + hList[6]) + (2 + hList[7]),
			.Grid.Top[9] = (36 + 32 +2) + (2 + hList[0]) + (2 + hList[1]) + (2 + hList[2]) + (2 + hList[3]) + (2 + hList[4]) + (2 + hList[5]) + (2 + hList[6]) + (2 + hList[7]) + (2 + hList[8]),
			.Grid.Top[10] = (36 + 32 +2) + (2 + hList[0]) + (2 + hList[1]) + (2 + hList[2]) + (2 + hList[3]) + (2 + hList[4]) + (2 + hList[5]) + (2 + hList[6]) + (2 + hList[7]) + (2 + hList[8]) + (2 + hList[9]),
			.Grid.Top[11] = (36 + 32 +2) + (2 + hList[0]) + (2 + hList[1]) + (2 + hList[2]) + (2 + hList[3]) + (2 + hList[4]) + (2 + hList[5]) + (2 + hList[6]) + (2 + hList[7]) + (2 + hList[8]) + (2 + hList[9]) + (2 + hList[10]),
				
			.Grid.Bottom[0] = (36 + 32 +2) + hList[0],
			.Grid.Bottom[1] = (36 + 32 +2) + (2 + hList[0]) + hList[1],
			.Grid.Bottom[2] = (36 + 32 +2) + (2 + hList[0]) + (2 + hList[1]) + hList[2],
			.Grid.Bottom[3] = (36 + 32 +2) + (2 + hList[0]) + (2 + hList[1]) + (2 + hList[2]) + hList[3],
			.Grid.Bottom[4] = (36 + 32 +2) + (2 + hList[0]) + (2 + hList[1]) + (2 + hList[2]) + (2 + hList[3]) + hList[4],
			.Grid.Bottom[5] = (36 + 32 +2) + (2 + hList[0]) + (2 + hList[1]) + (2 + hList[2]) + (2 + hList[3]) + (2 + hList[4]) + hList[5],
			.Grid.Bottom[6] = (36 + 32 +2) + (2 + hList[0]) + (2 + hList[1]) + (2 + hList[2]) + (2 + hList[3]) + (2 + hList[4]) + (2 + hList[5]) + hList[6],
			.Grid.Bottom[7] = (36 + 32 +2) + (2 + hList[0]) + (2 + hList[1]) + (2 + hList[2]) + (2 + hList[3]) + (2 + hList[4]) + (2 + hList[5]) + (2 + hList[6]) + hList[7],
			.Grid.Bottom[8] = (36 + 32 +2) + (2 + hList[0]) + (2 + hList[1]) + (2 + hList[2]) + (2 + hList[3]) + (2 + hList[4]) + (2 + hList[5]) + (2 + hList[6]) + (2 + hList[7]) + hList[8],
			.Grid.Bottom[9] = (36 + 32 +2) + (2 + hList[0]) + (2 + hList[1]) + (2 + hList[2]) + (2 + hList[3]) + (2 + hList[4]) + (2 + hList[5]) + (2 + hList[6]) + (2 + hList[7]) + (2 + hList[8]) + hList[9],
			.Grid.Bottom[10] = (36 + 32 +2) + (2 + hList[0]) + (2 + hList[1]) + (2 + hList[2]) + (2 + hList[3]) + (2 + hList[4]) + (2 + hList[5]) + (2 + hList[6]) + (2 + hList[7]) + (2 + hList[8]) + (2 + hList[9]) + hList[10],
			.Grid.Bottom[11] = (36 + 32 +2) + (2 + hList[0]) + (2 + hList[1]) + (2 + hList[2]) + (2 + hList[3]) + (2 + hList[4]) + (2 + hList[5]) + (2 + hList[6]) + (2 + hList[7]) + (2 + hList[8]) + (2 + hList[9]) + (2 + hList[10]) + hList[11],
			
			.Grid.UsingCount = 5,
			
			.Panel.Active = 1,
			.Panel.ItemType = piMemo,
			.Panel.Left = wList[1] + 6,
			.Panel.Top = (36 + 32 +2) + hList[0] +6,
			.Panel.Width = 502,
			.Panel.Heigh = 250,
			.Panel.Right = wList[1] + 6 + 502 -1,
			.Panel.Bottom = (36 + 32 +2) + hList[0] +6 + 250 -1,
			
			.PanelSmall.Active = 1,
			.PanelSmall.Left = wList[1] + 6,
			.PanelSmall.Top = (36 + 32 +2) + hList[0] +6 + 250 -1 + 1,
			.PanelSmall.Width = 502,
			.PanelSmall.Heigh = 42,
			.PanelSmall.Right = wList[1] + 6 + 502 -1,
			.PanelSmall.Bottom = (36 + 32 +2) + hList[0] +6 + 250 -1 + 1 + 42 -1,
		};
	public:
		TStaticText Caption;

		u32 Color;
	
		TRect Bound;	
		TRect Content;

		class TCtlPanel1 *aPanel;
		class TItemList	*IList;
		TEdit *pEdit;

		unsigned char Path0;
		unsigned char Path1Start;
		unsigned char Path1End;
		unsigned char Path0Ava;
		unsigned char Path1StartAva;
		unsigned char Path1EndAva;
		unsigned char IsPermission;
		unsigned char PermissionCmd;
		unsigned char IsEditting;
		unsigned char IsExtInput;
		unsigned char IsShowPresetList;
		unsigned char TextCodeOk;
		
		struct{
			unsigned char Inx;
			unsigned char InxMin;
			unsigned char Top;
			void Reset(){
				InxMin = 1;
				Inx = InxMin;
				Top = Inx;
			}
		}Tag, TagPreSetList, TagPanel;
	
		static TReadWriteData ReadWriteData;
		
		int Ava;
		
		int IsShow;
		unsigned char EditWhat;
		char TextList[8][36];
		
		unsigned int UnicodeCode;
		unsigned short Cp936Code;
		char TextCp936[8];
		
		char Text2WriteFix[36];
		char TextWritting[48];
		unsigned char Num2WriteCount;
		unsigned int Num2Write;
	public:
		TDescpWrite(){};
		void Init();			
		static void sDelayMs(unsigned int aMs);
			
		void RenderBackGround(void);

		void RenderBackGround(unsigned int aClr);
		void RenderContent(void);
		void DrawSelf(void);
		void DrawCommonByExReturn();;
		void DrawCaption(void);
		void Show();
		void FullRedraw(int Prm);
		void DrawFixText();
		
		void ShowInputWhat();
		
		void ClearSelected(void);
		void Check4Selected();
		void InitPanel();
		void DrawPreSetList();
		void DrawPreSetListTip();
			
		void PermissionCmdReturnDraw();
		void PermissionCmdGO();
			
		void ReadPreSetStr();
		void WritePreSetStr();
		void PreLoadReset();
			
		TGuiMsgReturn KeyIn(unsigned char aKey);
			
		void DescpBufInit();
		void FirstLoadText2Edit();
		void ReLoadText2Edit();
		void LoadText2Edit();
		
		void EditDescpReturn();
		void Redraw4DescpEdit();
		void AnalyTextWrite();
		void FillTextWrite();
			
		void LoadDescp(int aP0, int aP1, char *p);
		static void sRestoreDescp(int aP0, int aP1, char *p);
		void ShowRootPathResult(unsigned char aP0);
		
		
			
		static void sWrite2Flash(unsigned char aPath0);
		static void sReadFromFlash(unsigned char aPath0);
		
		void Write2FlashPreSet(unsigned char aPath0);
		
		void Write2Flash();
		void ReadFromFlash();
		
		int ExtRequst(unsigned char Prm){return 0;}
};



































#endif
